import { useState } from "react"
import { NavLink, useNavigate } from "react-router-dom";
import './form.css';


export default function Film() {
    const [data, setData] = useState({
        login: "",
        password: ""
    });
    const navigate = useNavigate();

    const [isError, setError] = useState(false);

    const handleFormChange = (e) => {
        setData({ ...data, [e.target.id]: e.target.value });
    }

    const formSubmit = async (e) => {
        e.preventDefault();
        const requestParams = {
            method: "POST",
            headers: {
                "Content-Type": "application/json",
            },
            body: JSON.stringify({ login: data.login, password: data.password }),
        };
        const response = await fetch("http://localhost:8080/jwt/login", requestParams);
        const result = await response.text();
        if (response.status === 200) {
            setError(false);
            localStorage.setItem("token", result);
            localStorage.setItem("user", data.login);
            getRole(result);
        } else {
            setError(true);
            localStorage.removeItem("token");
            localStorage.removeItem("user");
            localStorage.removeItem("role");
        }
    }

    const getRole = async function (token) {
        const requestParams = {
            method: "GET",
            headers: {
                "Content-Type": "application/json"
            }
        };
        const requestUrl = `http://localhost:8080/user?token=${token}`;
        const response = await fetch(requestUrl, requestParams);
        const result = await response.text();
        localStorage.setItem("role", result);
        window.dispatchEvent(new Event("storage"));
        navigate("/");
    }

    return (
        <>
            {isError && <div class="alert alert-warning" role="alert">
                Неверный логин или пароль
            </div>}

            <form onSubmit={formSubmit} className="form">
                <label htmlFor="name" className="form-label">Логин</label>
                <input type="text" value={data.name} id="login" className="form-control" required autoComplete="off"
                    onChange={handleFormChange} />
                <label htmlFor="surname" className="form-label">Пароль</label>
                <input type="password" value={data.surname} id="password" className="form-control" required autoComplete="off"
                    onChange={handleFormChange} />
                <button type="submit" className="btn btn-success mt-2 me-2">Вход</button>
                <NavLink type="submit" className="btn btn-info mt-2" to="/signup">Регистрация</NavLink>
            </form>
        </>
    )
}