package ru.ulstu.is.sbapp.calculator.controller;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import ru.ulstu.is.sbapp.calculator.service.CalculatorService;

@RestController
public class CalcController {
    private final CalculatorService speakerService;

    public CalcController(CalculatorService speakerService) {
        this.speakerService = speakerService;
    }

    @GetMapping("/sum")
    public String Sum(@RequestParam(value = "first", defaultValue = "1") Object first,
                      @RequestParam(value = "second", defaultValue = "1") Object second,
                      @RequestParam(value = "type", defaultValue = "int") String type) {
        return speakerService.Sum(first, second, type);
    }

    @GetMapping("/minus")
    public String Ras(@RequestParam(value = "first", defaultValue = "1") Object first,
                      @RequestParam(value = "second", defaultValue = "1") Object second,
                      @RequestParam(value = "type", defaultValue = "int") String type) {
        return speakerService.Ras(first, second, type);
    }

    @GetMapping("/reverse")
    public String Pros(@RequestParam(value = "first", defaultValue = "1") Object first,
                       @RequestParam(value = "second", defaultValue = "1") Object second,
                       @RequestParam(value = "type", defaultValue = "int") String type) {
        return speakerService.Rev(first, second, type);
    }

    @GetMapping("/comparison")
    public String Del(@RequestParam(value = "first", defaultValue = "1") Object first,
                      @RequestParam(value = "second", defaultValue = "1") Object second,
                      @RequestParam(value = "type", defaultValue = "int") String type) {
        return speakerService.Com(first, second, type);
    }
}
