package ru.ulstu.is.sbapp.socialNetwork.dto;

import ru.ulstu.is.sbapp.socialNetwork.models.Community;
import ru.ulstu.is.sbapp.socialNetwork.models.Music;
import ru.ulstu.is.sbapp.socialNetwork.models.UserModel;

import java.util.List;

public class MyUserDTO {
    private Long id;
    private String name;
    private String city;

    public MyUserDTO(){}

    public MyUserDTO(UserModel user){

        this.id = user.getId();
        this.name = user.getName();
        this.city = user.getCity();
        if(user.getMusics() != null) {
            this.music = user.getMusics().stream().map(Music::getName).toList();
        }
        if(user.getGroups() != null) {
            this.community = user.getGroups().stream().map(Community::getName).toList();
        }
    }
    public MyUserDTO(Long id, String name) {
        this.id = id;
        this.name = name;
    }
    private List<String> music;
    private List<String> community;

    public Long getId(){return id;}

    public String getName(){return name;}
    public void setName(String firstName){this.name = firstName;}

    public List<String> getMusic() {
        return music;
    }

    public List<String> getCommunity() {
        return community;
    }

    public void setCommunities(List<String> communities) {
        this.community = communities;
    }

    public void setMusics(List<String> musics) {
        this.music = musics;
    }

    public void setCity(String city){
        this.city = city;
    }

    public String getCity(){
        return city;
    }

    public void setMusic(List<String> music) {
        this.music = music;
    }

    public void setCommunity(List<String> community) {
        this.community = community;
    }

    @Override
    public String toString() {
        return "User{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", city='" + city + '\'' +
                '}';
    }

}
