package ru.ulstu.is.sbapp;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import ru.ulstu.is.sbapp.calculator.service.CalculatorService;


@SpringBootTest
class SbappApplicationTests {

	@Autowired
	CalculatorService calculatorService;

	@Test
	void contextLoads() {
	}
	@Test
	void testPlusInt() {
		final String res = calculatorService.Sum(10, 10, "int");
		Assertions.assertEquals(20, Integer.parseInt(res));
	}
	@Test
	void testMinusInt() {
		final String res = calculatorService.Ras(8, 4, "int");
		Assertions.assertEquals(4, Integer.parseInt(res));
	}
	@Test
	void testReverseInt() {
		final String res = calculatorService.Rev(10, 10, "int");
		Assertions.assertEquals(-20, Integer.parseInt(res));
	}
	@Test
	void testComparisonInt() {
		final String res = calculatorService.Com(8, 4, "int");
		Assertions.assertEquals(8, Integer.parseInt(res));
	}
	@Test
	void testPlusStr() {
		final String res = calculatorService.Sum("10", "10", "string");
		Assertions.assertEquals("1010", res);
	}
	@Test
	void testMinusStr() {
		final String res = calculatorService.Ras("846734", "4", "string");
		Assertions.assertEquals("8673", res);
	}
	@Test
	void testReverseStr() {
		final String res = calculatorService.Rev("846734", "312", "string");
		Assertions.assertEquals("213437648", res);
	}
	@Test
	void testComparisonStr() {
		final String res = calculatorService.Com("846734", "312", "string");
		Assertions.assertEquals("846734", res);
	}
	@Test
	void testNumberFormatException() {
		Assertions.assertThrows(NumberFormatException.class, () -> calculatorService.Sum("п", 3, "int"));
	}
	@Test
	void testSumDate(){
		final String res = calculatorService.Sum("2023-07-07", "0001-01-03", "date");
		Assertions.assertEquals("2024-08-10", res);
	}
	@Test
	void testRasDate(){
		final String res = calculatorService.Ras("2023-07-07", "2020-01-03", "date");
		Assertions.assertEquals("0003-06-04", res);
	}
	@Test
	void testComDate(){
		final String res = calculatorService.Com("2023-07-07", "2020-01-03", "date");
		Assertions.assertEquals("2023-07-07", res);
	}
}
